import 'package:flutter/material.dart';

import './rpx.dart';
import './colors.dart';

class AtLink extends StatefulWidget {
  final double fontSize;
  final FontWeight fontWeight;
  final EdgeInsetsGeometry padding;
  final EdgeInsetsGeometry margin;
  final Color color;
  final String text;
  final VoidCallback onPressed;

  AtLink({
    Key key,
    this.fontSize,
    this.fontWeight,
    this.padding,
    this.margin,
    this.text = '',
    this.color = AtColors.primaryColor,
    this.onPressed,
  }) : super(key: key);

  @override
  _AtLinkState createState() => _AtLinkState();
}

class _AtLinkState extends State<AtLink> with Rpx {
  bool _active = false;

  @override
  void initState() {
    _active = false;
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    rpxInit(context);

    return GestureDetector(
      onTap: widget.onPressed,
      onTapDown: (_) => onActive(),
      onTapUp: (_) => onUnActive(),
      onTapCancel: onUnActive,
      child: Container(
        color: Colors.transparent,
        padding: widget.padding,
        margin: widget.margin,
        child: Text(
          widget.text,
          style: TextStyle(
            fontSize: widget.fontSize ?? rpx(30),
            fontWeight: widget.fontWeight ?? FontWeight.normal,
            color: widget.color.withOpacity(_active ? 0.7 : 1),
          ),
        ),
      ),
    );
  }

  void onActive() {
    setState(() {
      _active = true;
    });
  }

  void onUnActive() {
    setState(() {
      _active = false;
    });
  }
}
